#### read (14 of 16 overloads)

Attempt to read a certain amount of data from a stream before returning.

    template<
        typename SyncReadStream,
        typename DynamicBuffer_v2>
    std::size_t read(
        SyncReadStream & s,
        DynamicBuffer_v2 buffers,
        asio::error_code & ec,
        constraint_t< is_dynamic_buffer_v2< DynamicBuffer_v2 >::value >  = 0);

This function is used to read a certain number of bytes of data from a stream. The call will block until one of the following conditions is true:

- The supplied buffer is full (that is, it has reached maximum size).
- An error occurred.

This operation is implemented in terms of zero or more calls to the stream's read_some function.

###### Parameters

s

  The stream from which the data is to be read. The type must support the SyncReadStream concept.

buffers

  The dynamic buffer sequence into which the data will be read.

ec

  Set to indicate what error occurred, if any.

###### Return Value

The number of bytes transferred.

###### Remarks

This overload is equivalent to calling:

    asio::read(
       s, buffers,
       asio::transfer_all(), ec);